/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { ResourceQuotaDtoResponse } from '../../@coscine/model';
/**
 * ProjectResourceQuotaApi - axios parameter creator
 * @export
 */
export const ProjectResourceQuotaApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {string} resourceId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdResourcesResourceIdQuotaOptions: async (projectId: string, resourceId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdResourcesResourceIdQuotaOptions', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('apiV2ProjectsProjectIdResourcesResourceIdQuotaOptions', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/quota`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the resource quota for a specific resource in a project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceId The ID of the resource.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getQuotaForResourceForProject: async (projectId: string, resourceId: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('getQuotaForResourceForProject', 'projectId', projectId)
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('getQuotaForResourceForProject', 'resourceId', resourceId)
            const localVarPath = `/api/v2/projects/{projectId}/resources/{resourceId}/quota`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ProjectResourceQuotaApi - functional programming interface
 * @export
 */
export const ProjectResourceQuotaApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ProjectResourceQuotaApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {string} projectId 
         * @param {string} resourceId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2ProjectsProjectIdResourcesResourceIdQuotaOptions(projectId: string, resourceId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2ProjectsProjectIdResourcesResourceIdQuotaOptions(projectId, resourceId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectResourceQuotaApi.apiV2ProjectsProjectIdResourcesResourceIdQuotaOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the resource quota for a specific resource in a project.
         * @param {string} projectId The Id or slug of the project.
         * @param {string} resourceId The ID of the resource.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getQuotaForResourceForProject(projectId: string, resourceId: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ResourceQuotaDtoResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getQuotaForResourceForProject(projectId, resourceId, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['ProjectResourceQuotaApi.getQuotaForResourceForProject']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * ProjectResourceQuotaApi - factory interface
 * @export
 */
export const ProjectResourceQuotaApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ProjectResourceQuotaApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {ProjectResourceQuotaApiApiV2ProjectsProjectIdResourcesResourceIdQuotaOptionsRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2ProjectsProjectIdResourcesResourceIdQuotaOptions(requestParameters: ProjectResourceQuotaApiApiV2ProjectsProjectIdResourcesResourceIdQuotaOptionsRequest, options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2ProjectsProjectIdResourcesResourceIdQuotaOptions(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the resource quota for a specific resource in a project.
         * @param {ProjectResourceQuotaApiGetQuotaForResourceForProjectRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getQuotaForResourceForProject(requestParameters: ProjectResourceQuotaApiGetQuotaForResourceForProjectRequest, options?: RawAxiosRequestConfig): AxiosPromise<ResourceQuotaDtoResponse> {
            return localVarFp.getQuotaForResourceForProject(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV2ProjectsProjectIdResourcesResourceIdQuotaOptions operation in ProjectResourceQuotaApi.
 * @export
 * @interface ProjectResourceQuotaApiApiV2ProjectsProjectIdResourcesResourceIdQuotaOptionsRequest
 */
export interface ProjectResourceQuotaApiApiV2ProjectsProjectIdResourcesResourceIdQuotaOptionsRequest {
    /**
     * 
     * @type {string}
     * @memberof ProjectResourceQuotaApiApiV2ProjectsProjectIdResourcesResourceIdQuotaOptions
     */
    readonly projectId: string

    /**
     * 
     * @type {string}
     * @memberof ProjectResourceQuotaApiApiV2ProjectsProjectIdResourcesResourceIdQuotaOptions
     */
    readonly resourceId: string
}

/**
 * Request parameters for getQuotaForResourceForProject operation in ProjectResourceQuotaApi.
 * @export
 * @interface ProjectResourceQuotaApiGetQuotaForResourceForProjectRequest
 */
export interface ProjectResourceQuotaApiGetQuotaForResourceForProjectRequest {
    /**
     * The Id or slug of the project.
     * @type {string}
     * @memberof ProjectResourceQuotaApiGetQuotaForResourceForProject
     */
    readonly projectId: string

    /**
     * The ID of the resource.
     * @type {string}
     * @memberof ProjectResourceQuotaApiGetQuotaForResourceForProject
     */
    readonly resourceId: string
}

/**
 * ProjectResourceQuotaApi - object-oriented interface
 * @export
 * @class ProjectResourceQuotaApi
 * @extends {BaseAPI}
 */
export class ProjectResourceQuotaApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {ProjectResourceQuotaApiApiV2ProjectsProjectIdResourcesResourceIdQuotaOptionsRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectResourceQuotaApi
     */
    public apiV2ProjectsProjectIdResourcesResourceIdQuotaOptions(requestParameters: ProjectResourceQuotaApiApiV2ProjectsProjectIdResourcesResourceIdQuotaOptionsRequest, options?: RawAxiosRequestConfig) {
        return ProjectResourceQuotaApiFp(this.configuration).apiV2ProjectsProjectIdResourcesResourceIdQuotaOptions(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the resource quota for a specific resource in a project.
     * @param {ProjectResourceQuotaApiGetQuotaForResourceForProjectRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProjectResourceQuotaApi
     */
    public getQuotaForResourceForProject(requestParameters: ProjectResourceQuotaApiGetQuotaForResourceForProjectRequest, options?: RawAxiosRequestConfig) {
        return ProjectResourceQuotaApiFp(this.configuration).getQuotaForResourceForProject(requestParameters.projectId, requestParameters.resourceId, options).then((request) => request(this.axios, this.basePath));
    }
}

